<?php
/* --------------------------------------------------------------
   dependent.inc.php 2016-07-14
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2016 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Add FedEx Parcel Service
 */
$t_check = $this->query('SELECT * FROM `parcel_services_description` WHERE `url` LIKE "%fedex.com%"', true);
if($t_check->num_rows == 0)
{
	$query        = 'INSERT INTO `parcel_services` (`name`, `default`) VALUES ("FedEx", 0)';
	$lastInsertId = $this->query($query);
	$t_success &= (boolean)$lastInsertId;
	
	$query = 'INSERT INTO `parcel_services_description` (`parcel_service_id`, `language_id`, `url`, `comment`)
				VALUES
					(' . $lastInsertId . ', 1, "https://www.fedex.com/apps/fedextrack/?action=track&cntry_code=en&trackingnumber={TRACKING_NUMBER}", "You can access the shipment tracking for your order by visiting the link above."),
					(' . $lastInsertId
	         . ', 2, "https://www.fedex.com/apps/fedextrack/?action=track&cntry_code=de&trackingnumber={TRACKING_NUMBER}", "Die Sendungsverfolgung für Ihre Bestellung können Sie über den oben stehenden Link aufrufen.")';
	$t_success &= (boolean)$this->query($query, true);
}

/**
 * set unique index for configuration_key in configuration table
 */
$t_success &= $this->set_index('configuration', 'UNIQUE', array('configuration_key'), 'configuration_key');

/**
 * Add MyHermes Parcel Service
 * @see https://tracker.gambio-server.net/issues/47337
 */

// Query to check for existant entry.
$checkForEntryQuery = $this->query('SELECT * FROM `parcel_services_description` WHERE `url` LIKE "%myhermes.de%"',
                                   true);

// Add the parcel service if no entries have been found.
if($checkForEntryQuery->num_rows === 0)
{
	// Query to insert parcel service.
	$insertQuery = 'INSERT INTO `parcel_services` (`name`, `default`) VALUES ("MyHermes", 0)';

	// Execute query and fetch the entry ID.
	$insertQueryEntryId = $this->query($insertQuery);

	// Refesh success state.
	$t_success &= (boolean)$insertQueryEntryId;

	// Parcel service tracking URL.
	$trackingUrl = 'https://www.myhermes.de/wps/portal/paket/SISYR?auftragsNummer={TRACKING_NUMBER}';

	// Query to insert the respective description for parcel service.
	$insertDescriptionQuery = '
		INSERT INTO
			`parcel_services_description` (`parcel_service_id`, `language_id`, `url`, `comment`)
		VALUES
			(' . $insertQueryEntryId . ', 1, "' . $trackingUrl . '", "You can access the shipment tracking for your order by visiting the link above."),
			(' . $insertQueryEntryId . ', 2, "' . $trackingUrl . '", "Die Sendungsverfolgung für Ihre Bestellung können Sie über den oben stehenden Link aufrufen.")
	';

	// Refesh success state.
	$t_success &= (boolean)$this->query($insertDescriptionQuery, true);
}