<?php
/* --------------------------------------------------------------
   dependent.inc.php 2016-09-05
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2016 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Add Cash on Delivery Upper Limit
 */

// Query to check for existant entry.
$checkForEntryQuery = $this->query('SELECT `configuration_key` FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_COD_UPPER_LIMIT"', true);

// Add the payment cash on delivery upper limit if no entries have been found.
if($checkForEntryQuery->num_rows === 0)
{
	// Query to insert the payment cash on delivery upper limit configuration.
	$insertQuery = 'INSERT INTO `configuration` 
					SET `configuration_key` = "MODULE_PAYMENT_COD_UPPER_LIMIT", 
					`configuration_value` = "",  
					`configuration_group_id` = "6", 
					`sort_order` = "0", 
					`date_added` = now()';
	
	// Refesh success state.
	$t_success &= (boolean)$this->query($insertQuery);
}

/**
 * Add privacy checkbox configuration values
 */

$privacyOptions = array(
	'PRIVACY_CHECKBOX_REGISTRATION',
	'PRIVACY_CHECKBOX_CALLBACK',
	'PRIVACY_CHECKBOX_CONTACT',
	'PRIVACY_CHECKBOX_ASK_PRODUCT_QUESTION',
	'PRIVACY_CHECKBOX_FOUND_CHEAPER',
	'PRIVACY_CHECKBOX_REVIEWS',
	'PRIVACY_CHECKBOX_ACCOUNT_EDIT',
	'PRIVACY_CHECKBOX_ADDRESS_BOOK',
	'PRIVACY_CHECKBOX_NEWSLETTER',
	'PRIVACY_CHECKBOX_CHECKOUT_SHIPPING',
	'PRIVACY_CHECKBOX_CHECKOUT_PAYMENT'
);

foreach($privacyOptions as $gm_key)
{
	$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "' . $gm_key . '"', true);
	if($check->num_rows == 0)
	{
		$query = 'INSERT INTO `gm_configuration` 
					SET 
						`gm_key` = "' . $gm_key . '",
						`gm_value` = "0"';
		$t_success &= $this->query($query, true);
	}
}

/**
 * Set individual privacy notice phrases
 */

$phraseNames = array(
	'ENTRY_SHOW_PRIVACY_REGISTRATION',
	'ENTRY_SHOW_PRIVACY_CALLBACK',
	'ENTRY_SHOW_PRIVACY_CONTACT',
	'ENTRY_SHOW_PRIVACY_ASK_PRODUCT_QUESTION',
	'ENTRY_SHOW_PRIVACY_FOUND_CHEAPER',
	'ENTRY_SHOW_PRIVACY_REVIEWS',
	'ENTRY_SHOW_PRIVACY_ACCOUNT_CONTACT',
	'ENTRY_SHOW_PRIVACY_ADDRESS_BOOK',
	'ENTRY_SHOW_PRIVACY_NEWSLETTER',
	'ENTRY_SHOW_PRIVACY_CHECKOUT_SHIPPING',
	'ENTRY_SHOW_PRIVACY_CHECKOUT_PAYMENT'
);

$phrases = $this->query('SELECT 
								`language_id`, 
								`phrase_text` 
							FROM `language_phrases_edited` 
							WHERE 
								`section_name` = "general" AND 
								`phrase_name` = "ENTRY_SHOW_PRIVACY"', true);
while($phrase = $phrases->fetch_assoc())
{
	foreach($phraseNames as $phraseName)
	{
		$check = $this->query('SELECT * FROM `language_phrases_edited` 
								WHERE 
									`language_id` = ' . $phrase['language_id'] . ' AND
									`section_name` = "general" AND 
									`phrase_name` = "' . $phraseName . '"', true);
		if($check->num_rows == 0)
		{
			$query = 'INSERT INTO `language_phrases_edited` 
						SET 
							`language_id` = ' . $phrase['language_id'] . ',
							`section_name` = "general",
							`phrase_name` = "' . $phraseName . '",
							`phrase_text` = "' . $this->real_escape_string($phrase['phrase_text']) . '"';
			$t_success &= $this->query($query, true);
		}
	}
}


/**
 * Correct negative order status IDs
 */

$orderStatus = $this->query('
	SELECT 
		s.`orders_status_history_id`, 
		s.`orders_id`,
		o.`orders_status` 
	FROM 
		orders_status_history s, 
		orders o 
	WHERE 
		s.`orders_status_id` < 0 AND 
		s.`orders_id` = o.`orders_id`', true);
while($row = $orderStatus->fetch_assoc())
{
	$orderStatusIdResult = $this->query('
		SELECT `orders_status_id` 
		FROM `orders_status_history` 
		WHERE 
			`orders_id` = ' . $row['orders_id'] .  ' AND
			`orders_status_history_id` < ' . $row['orders_status_history_id'] . ' AND
			`orders_status_id` >= 0
		ORDER BY `orders_status_history_id` DESC
		LIMIT 1', true);
	if($orderStatusIdResult->num_rows === 1)
	{
		$statusIdRow = $orderStatusIdResult->fetch_assoc();
		$orderStatusID = $statusIdRow['orders_status_id'];
	}
	else
	{
		$orderStatusIdResult = $this->query('
			SELECT `configuration_value` 
			FROM `configuration` 
			WHERE 
				`configuration_key` = "DEFAULT_ORDERS_STATUS_ID"', true);
		$statusIdRow = $orderStatusIdResult->fetch_assoc();
		$orderStatusID = $statusIdRow['configuration_value'];
	}
	
	$query = 'UPDATE `orders_status_history` 
				SET `orders_status_id` = ' . $orderStatusID . ' 
				WHERE `orders_status_history_id` = ' . $row['orders_status_history_id'];
	
	$t_success &= is_numeric($this->query($query));
	
	if((int)$row['orders_status'] < 0)
	{
		$query = 'UPDATE `orders` 
					SET `orders_status` = ' . $orderStatusID . ' 
					WHERE `orders_id` = ' . $row['orders_id'];
		
		$t_success &= is_numeric($this->query($query));
	}
}